import {useState} from 'react';
import {TransactionController} from './TransactionController';

function App() {
  
  const [file, setFile] = useState(null);
  const [transactions, setTransactions] = useState([]);

  function handleUpload() {
    const formData = new FormData();
    formData.append('file', file);
    fetch('/api/upload/', {
      method: 'POST',
      body: formData,
    })
    .then((response) => response.json())
    .then((data) => {
      setTransactions(data);
    })
  }

  return (
    <div className="bg-gray-100 h-screen flex flex-col justify-center items-center">
      <div className="bg-white rounded-lg shadow-lg p-8">
        <h1 className="text-2xl font-bold mb-4">Welcome to the Budget App</h1>
        <p className="text-gray-500 mb-4">This is a simple app that will help you categorize your expenses.</p>
        <p className="text-gray-500 mb-4">Upload a CSV file and we will do the rest.</p>
        <div className="flex justify-center">
          <input type="file" className="" onChange={(e) => setFile(e.target.files[0])} />
          <button className="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded" onClick={() => handleUpload()}>
            Upload CSV
          </button>
        </div>
      </div>
      <TransactionController transactions={transactions} />
    </div>
  )
}
  
export default App