import React from 'react';
import {TransactionsList} from './TransactionsList';

function TransactionController({transactions}) {
    if(transactions.length === 0) {
        return (
            <div className="bg-white rounded-lg shadow-lg p-8 mt-6">
                <h1 className="text-2xl font-bold mb-4">Transactions</h1>
                <p className="text-gray-500 mb-4">No transactions to display.</p>
            </div>
        )
    }

    for(let i = 0; i < transactions.length; i++) {
        transactions[i].id = i;
    }

    // Sort transactions by category and render a transactions list for each category
    let sortedTransactions = {};

    transactions.map((transaction) => {
        if(sortedTransactions[transaction.Category] === undefined) {
            sortedTransactions[transaction.Category] = [];
            sortedTransactions[transaction.Category].push(transaction);
        } else {
            sortedTransactions[transaction.Category].push(transaction);
        }
    })

    return (
        <div className="bg-white rounded-lg shadow-lg p-8 mt-6">
                <h1 className="text-2xl font-bold mb-4">Transactions</h1>
                {Object.keys(sortedTransactions).map((category) => (
                    <TransactionsList key={category} category={category} transactions={sortedTransactions[category]} />
                ))}
            </div>
    )
}

export { TransactionController }
