import React from 'react';

function TransactionsList({category, transactions}) {
    return (
        <div className="bg-slate-100 rounded-lg shadow-lg p-8 mt-6">
            <h1 className="text-2xl font-bold mb-4">{category}</h1>
            <table className="table-auto">
                <thead>
                    <tr>
                        <th className="px-4 py-2">Date</th>
                        <th className="px-4 py-2">Description</th>
                        <th className="px-4 py-2">Credit</th>
                        <th className="px-4 py-2">Debit</th>
                    </tr>
                </thead>
                <tbody>
                    {transactions.map((transaction) => (
                        <tr key={transaction.id}>
                            <td className="border px-4 py-2">{transaction.Date}</td>
                            <td className="border px-4 py-2">{transaction.Description}</td>
                            <td className="border px-4 py-2">{transaction.Credit}</td>
                            <td className="border px-4 py-2">{transaction.Debit}</td>
                        </tr>
                    ))}
                </tbody>
            </table>
        </div>
    )
}

export { TransactionsList }
